
// -------------------------------------------------------------------------//  Notes: 4MHzNbN
//     SW1  RA3,  SW2  RA5
//     LED1 RC0,  LED2 RC1,  LED3 RC2,  LED4 RC3
//     POT  RA4 (AN3)
//    Language: MPLABX XC8
//    Target:   PIC16F1459
// -------------------------------------------------------------------------

#include <xc.h>
#include <stdio.h>
#include "bd_confg.h"
// board_config --------------------------------------------------------

// ADC ------------------------------------------------------------------
void intADC(void){
    TRISAbits.TRISA4 = 1;       // RA4(AN3)͓͂ɐݒ
    ANSELAbits.ANSA4 = 1;       // RA4(AN3)̓AiOɐݒ
    ADCON2 = 0b00000000;        // ADϊ̓vO̖߂ŊJn
    ADCON1 = 0b11000000;        // Elߏo, ADϊNbNFosc/4
                                // d VDD
    ADCON0 = 0b00001101;        // AiO AN3(RA4),ADC ON
}
unsigned int resADC(void) {
    __delay_ms(5);              // AD`[W
    GO = 1;                     // ADϊJn
    while(GO);                  // ADϊI҂
    return ADRES;               // AD16rbgŎ擾
}
// I2C LCD --------------------------------------------------------------
//********************************************************************
// I2C ֘A
//********************************************************************
//-------- i2cłPbytef[^𑗐M -----------------------
//  ȉ̈Kv
//  addr F SlavẽAhX
//  cont F Slave֐R[h
//  data F Mf[^
//  NACKBusՓ˂Ȃǂ̑Ή͍sĂȂ
// -----------------------------------------------------------
void i2cByteWrite(char addr, char cont, char data){
    SEN = 1;                       // Start condition Jn
    while(SEN);                    // Start condition mF
    i2cTxData(addr);               // AhXM
    i2cTxData(cont);               // R[hM
    i2cTxData(data);               // f[^M
    SSP1IF = 0;                    // ItONA
    PEN = 1;                       // Stop condition Jn
    while(PEN);                    // Stop condition mF
}
//-------- SSPBUFɂPۑMI҂ -----------------
void i2cTxData(char data){
    SSP1IF = 0;                    // ItONA
    SSPBUF = data;                 // f[^Zbg
    while(!SSP1IF);                // MI҂
}
//********************************************************************
// LCD ֘A
//********************************************************************
//--------  --------------------------------------
void intI2CLCD(void){
    ANSELB &= 0b01010000;          // RB7,RB5fW^I/Oɂ
    TRISB  |= 0b10100000;          // PortBI/Oɂ
    WPUB   |= 0b10100000;          // RB7,RB5vAbv
    nWPUEN  = 0;                   // vAbvONɂ
    SSPCON3 = 0;
    SSPCON2 = 0;
    SSPCON1 = 0b00101000;          // I2C}X^[[hw
    SSPSTAT = 0b10000000;          // Slew rate for 100 kHz
    SSPADD  = 9;                   // I2CNbNg100KHz for 4MHz
    __delay_ms(100);
    LCD_cmd(0x38);                 // 8bit 2s \߃[h
    LCD_cmd(0x39);                 // 8bit 2s g߃[h
    LCD_cmd(0x14);                 // OSC  BIAS ݒ1/5
                                   // RgXgݒ
    LCD_cmd(0x70 + (CONTRAST & 0x0F));
    LCD_cmd(0x5C + (CONTRAST >> 4));
    LCD_cmd(0x6B);                 // Ffollwer
    __delay_ms(100);
    __delay_ms(100);
    LCD_cmd(0x38);                 // \߃[h
    LCD_cmd(0x0C);                 // Display On
    LCD_cmd(0x01);                 // Clear Display
}
//-------- P\
void LCD_dat(char chr){
    i2cByteWrite(0x7C, 0x40, chr);
    __delay_us(50);                // 50sec
}
//-------- R}ho
void LCD_cmd(char cmd){
    i2cByteWrite(0x7C, 0x00, cmd);
    if(cmd & 0xFC)                 // ʂUrbgɂP閽
        __delay_us(50);            // 50usec
    else
        __delay_ms(2);             // 2msec ClearHomeR}h
}
//-------- S ------------------------------------------------
void LCD_clr(void){
    LCD_cmd(0x01);                 //ClearR}ho
}
//-------- J[\ʒuw --------------------------------------
void LCD_posyx(char ypos, char xpos){
    unsigned char pcode;
    switch(ypos & 0x03){           // cʒu擾
        case 0: pcode=0x80;break;  // 1s
        case 1: pcode=0xC0;break;  // 2s
    }
    LCD_cmd(pcode += xpos);        // ʒu
}

// **************** printf Routen *****************************
// LCD  printf֐gpł悤ɂ邽 putch ݒ肷
void putch(char data) {
        LCD_dat(data);             // LCD ւ̈ꕶ\֐
}

